/* 
 * File:   Timer.h
 * Author: peter
 *
 * Created on 21. Dezember 2012, 15:26
 */

#ifndef TIMER_H
#define	TIMER_H

#include <sys/time.h>
#include "Logger.h"

using namespace std;

extern Logger logger;

class Timer {
public:
    Timer() {
        resetTimer();
    };
    
    void resetTimer() {
        startTime=0;
        endTime=0;
        tfmlong=0;
        timeout=false;
        movestogo=-1;
    }
    
    void startTimer() {
        timeval tmp;
        gettimeofday(&tmp,0);
        startTime=tmp.tv_sec*1000000+tmp.tv_usec;
    }
    
    void stopTimer() {
        timeval tmp;
        gettimeofday(&tmp,0);
        endTime=tmp.tv_sec*1000000+tmp.tv_usec;
    }
    
    void setTimeForMove(long timeForMove, int movestogo) {
        this->movestogo=movestogo;
        timeForMove-=500;
        double tfmd = double(timeForMove)/(movestogo+2); // millisekunden für zug
        string a;
        a.append("tfmd: ");
        a.append(double2String(tfmd));
        cout << a << endl;
        logger.log(a);
                
        tfmd = tfmd*1000; // *0.9; // mikrosekunden für zug
        tfmlong = (unsigned long)tfmd;
    }
    
    unsigned long getTimeout() {
//        cout << "Timeout:" << endl;
//        cout << "starttime: " << startTime << endl;
//        cout << "tfmlong: " << tfmlong << endl;
//        cout << "sum: " << (startTime+tfmlong) << endl;
        
        return startTime+tfmlong;
    }
    
    bool checkTimeout() {
        if (movestogo<0)
            timeout=false;
        else {
            timeval tmp;
            gettimeofday(&tmp,0);
            timeout=((unsigned long)(tmp.tv_sec*1000000+tmp.tv_usec)>getTimeout());
        }
        return timeout;
    }
    
    bool isTimeout() {
        return timeout;
    }
    
    double getStartEndDiffSeconds() {
        if (endTime && startTime && endTime>startTime)
            return double(endTime-startTime)/1000000;
        else
            return 0;
    }
    
    virtual ~Timer() {};
private:
    unsigned long startTime;
    unsigned long endTime;
    unsigned long tfmlong;
    bool timeout;
    int movestogo;
};

#endif	/* TIMER_H */

