/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   PositionEvalFastQuiesce.h
 * Author: peter
 *
 * Created on 20. Februar 2014, 18:32
 */

#ifndef POSITIONEVALFASTQUIESCE_H
#define	POSITIONEVALFASTQUIESCE_H

#include "PositionEvalFast.h"

//! extends PositionEvalFast with Quiescence-Search
/*!
 * This class extends the simple alpha-beta-search with a
 * quiescience search to avoid the horizont-effect.
 * The class uses the fast-evaluation from the
 * PositionEvalFast-class.
*/
class PositionEvalFastQuiesce : public PositionEvalFast {
public:
    string getName() {return "FastQuiesce"; };
    
private:
    int negaMax(int alpha, int beta, int curr_depth, int depth);
    int quiesce(int alpha, int beta, int curr_depth);
};

#endif	/* POSITIONEVALFASTQUIESCE_H */

