/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   PositionKingCheck.h
 * Author: peter
 *
 * Created on 20. Februar 2014, 18:23
 */

#ifndef POSITIONKINGCHECK_H
#define	POSITIONKINGCHECK_H

#include "PositionEvalQuiesce.h"

//! Extends PositionEvalQuiesce with legal-move-generation
/*!
 * This game-mode is based on the class PositionEvalQuiesce,
 * so it uses an alpha-beta-search with quiescience-search and
 * a detailed evaluation-function and just uses legal
 * moves in the move-generation.
*/
class PositionKingCheck : public PositionEvalQuiesce {
public:
    string getName() {return "KingCheck"; };
    
private:
    int negaMax(int alpha, int beta, int curr_depth, int depth);
};

#endif	/* POSITIONKINGCHECK_H */