/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   PositionUCTSearchSimilarity.h
 * Author: peter
 *
 * Created on 20. Februar 2014, 18:32
 */

#ifndef POSITIONUCTSEARCHSIMILARITY_H
#define	POSITIONUCTSEARCHSIMILARITY_H

#include <stdlib.h>
#include <time.h>
#include "PositionUCTSearch.h"

//! A Monte-Carlo-Tree-Search Game-Mode with UCT-Selection and Similarity
/*!
 * This class doesn't have an evaluation-function, but uses
 * a monte-carlo-tree-search-method to calculate the best move
 * from a given position. Is uses a UCT-Method for selecting nodes
 * in the game-tree. This class uses the UCTNodeSimilarity-Class.
 * The UCT-Search uses a similarity hash-function to prune
 * the game-tree.
*/
class PositionUCTSearchSimilarity : public PositionUCTSearch {
public:
    string getName() {return getNameUCTAppendix("UCTSearchSimilarity");};
    void go(unsigned int depth);
};

#endif	/* POSITIONUCTSEARCHSIMILARITY_H */